/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2005-2008 by TAKAGI Nobuhisa
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/*!
 *  \file   toppers/codeset.hpp
 *  \brief  R[hʂɊւ錾`
 */
#ifndef TOPPERS_CODESET_HPP_
#define TOPPERS_CODESET_HPP_

#include "toppers/config.hpp"

namespace toppers
{

  /*!
   *  \enum   codeset_t
   *  \brief  R[h
   *
   *  ł͓{݂̂lĂ܂B
   */
  enum codeset_t
  {
    ascii,
    shift_jis,
    euc_jp,
    utf8
  };

  template < codeset_t Codeset >
    inline bool is_lead( char c )
  {
    return static_cast< unsigned char >( c ) & 0x80;
  }

  template <>
    inline bool is_lead< shift_jis >( char c )
  {
    int ch = static_cast< unsigned char >( c );
    return ( 0x81 <= ch && ch <= 0x9f ) || ( 0xe0 <= ch && ch <= 0xef );
  }

  template <>
    inline bool is_lead< utf8 >( char c )
  {
    return ( static_cast< unsigned char >( c ) & 0xc0 ) != 0;
  }

}

#endif  // ! TOPPERS_CODESET_HPP_
